/*				**** DATA DEMO ****
 *
 * This program demonstrates a number of data structures
 * and how they can be used
 */

#include <stdio.h>
#include <stdlib.h>

/* include file that contains definitions of our structures */
#include "datademo.h"

/*
 * table to map use flag to desciption
 */
struct UseDesc usetbl[] = {
	USE_NOT, "Empty",
   USE_YES, "In Use",
   USE_DEL, "Deleted",
   -1, NULL		/* signals end of table */
};

/* function prototypes */
void init_structures(void);
char *get_use_string(int use);

int
main()
{
	char buf[BUFSIZ];
   int opt, running = 1;

   printf("Welcome to the Data Structures Demo!\n");
   init_structures();			/* initialize data structures */

   /* loop forever until user selects 'quit' option */
   while (running)
   {
   	printf("\nOptions are:\n");
      printf("1. Work with Arrays\n");
      printf("2. Work with Hash Table\n");
      printf("3. Work with Linked List\n");
      printf("4. Work with Stacks\n");
      printf("5. Work with Queues\n");
      printf("9. Quit\n");
      printf("Enter option: ");
      gets(buf);
      opt = atoi(buf);
      if (buf[0] == 'q') opt = 9;
      switch(opt)
      { /* process menu option */
      case 1: running = do_array(); break;
      case 2: running = do_hash_table(); break;
      case 3: running = do_linked_list(); break;
      case 4: running = do_stack(); break;
      case 5: running = do_queue(); break;
      case 9: running = 0; break;
      default: printf("Invalid option - try again!\n");
      }
   }
   return 0;
}

void
init_structures(void)
{ /* initialize data structures */
	init_array();
   init_hash_table();
	init_linked_list();
   init_queue();
   init_stack();
}

char *
get_use_desc(int use)
{
	int i;

   for (i=0; usetbl[i].desc != NULL; i++)
   { /* search use table for matching use flag */
   	if (usetbl[i].use == use) return usetbl[i].desc;
   }
	/* if we didn't find it, then we were passed a bad value */
   return "Unknown";	/* error return */
}

